import { Component, Input, ContentChildren, ViewChild, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BrushComponent = /** @class */ (function () {
    function BrushComponent() {
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    BrushComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (this.signalNotifier) {
            this.signalNotifier.notify();
        }
    };
    BrushComponent.decorators = [
        { type: Component, args: [{
                    selector: 'highlight-brush',
                    template: ''
                }] }
    ];
    /** @nocollapse */
    BrushComponent.ctorParameters = function () { return []; };
    BrushComponent.propDecorators = {
        brushClass: [{ type: Input }],
        lineWidth: [{ type: Input }],
        lineCap: [{ type: Input }],
        lineJoin: [{ type: Input }],
        strokeStyle: [{ type: Input }],
        lineDash: [{ type: Input }],
        fillStyle: [{ type: Input }]
    };
    return BrushComponent;
}());
var BrushWithDefaults = /** @class */ (function () {
    function BrushWithDefaults(brush) {
        this.brush = brush;
    }
    /**
     * @return {?}
     */
    BrushWithDefaults.prototype.lineDash = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var lineDash = this.getValue('lineDash', [0]);
        if (typeof lineDash === 'string') {
            return lineDash.split(',').map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return parseInt(value.trim(), 10); }));
        }
        else {
            return lineDash;
        }
    };
    /**
     * @return {?}
     */
    BrushWithDefaults.prototype.lineCap = /**
     * @return {?}
     */
    function () {
        return this.getValue('lineCap', 'round');
    };
    /**
     * @return {?}
     */
    BrushWithDefaults.prototype.lineWidth = /**
     * @return {?}
     */
    function () {
        return this.getValue('lineWidth', 1);
    };
    /**
     * @return {?}
     */
    BrushWithDefaults.prototype.lineJoin = /**
     * @return {?}
     */
    function () {
        return this.getValue('lineJoin', 'round');
    };
    /**
     * @return {?}
     */
    BrushWithDefaults.prototype.strokeStyle = /**
     * @return {?}
     */
    function () {
        return this.getValue('strokeStyle', '#FFFFFF00');
    };
    /**
     * @return {?}
     */
    BrushWithDefaults.prototype.fillStyle = /**
     * @return {?}
     */
    function () {
        return this.getValue('fillStyle', '#FFFFFF00');
    };
    /**
     * @template T
     * @param {?} field
     * @param {?} defaultValue
     * @return {?}
     */
    BrushWithDefaults.prototype.getValue = /**
     * @template T
     * @param {?} field
     * @param {?} defaultValue
     * @return {?}
     */
    function (field, defaultValue) {
        if (this.brush && this.brush[field]) {
            return this.brush[field];
        }
        return defaultValue;
    };
    return BrushWithDefaults;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AreaComponent = /** @class */ (function () {
    function AreaComponent() {
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    AreaComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (this.signalNotifier && changes.brushClass) {
            this.signalNotifier.notify();
        }
    };
    AreaComponent.decorators = [
        { type: Component, args: [{
                    selector: 'highlight-area',
                    template: "<area *ngIf=\"!inactive\" [href]=\"href\" shape=\"poly\" [coords]=\"coords\" [title]=\"title\" [alt]=\"alt\"/>\r\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    AreaComponent.ctorParameters = function () { return []; };
    AreaComponent.propDecorators = {
        href: [{ type: Input }],
        brushClass: [{ type: Input }],
        title: [{ type: Input }],
        alt: [{ type: Input }],
        coords: [{ type: Input }],
        inactive: [{ type: Input }]
    };
    return AreaComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SignalNotifier = /** @class */ (function () {
    function SignalNotifier(delay, handler) {
        this.delay = delay;
        this.handler = handler;
    }
    /**
     * @return {?}
     */
    SignalNotifier.prototype.notify = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.timer) {
            window.clearTimeout(this.timer);
        }
        this.timer = window.setTimeout((/**
         * @return {?}
         */
        function () {
            _this.run();
        }), this.delay);
    };
    /**
     * @private
     * @return {?}
     */
    SignalNotifier.prototype.run = /**
     * @private
     * @return {?}
     */
    function () {
        this.timer = null;
        this.handler();
    };
    return SignalNotifier;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MapComponent = /** @class */ (function () {
    function MapComponent() {
        this.brushesMap = {};
        this.signalNotifier = new SignalNotifier(100, this.repaint.bind(this));
    }
    /**
     * @return {?}
     */
    MapComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.context = this.canvasMap.nativeElement.getContext('2d');
        this.mainContainer.nativeElement.style.backgroundImage = "url(" + this.src + ")";
        this.prepareBrushesMap();
        this.reorderLayers();
        this.areas.forEach((/**
         * @param {?} area
         * @return {?}
         */
        function (area) {
            area.signalNotifier = _this.signalNotifier;
        }));
        this.brushes.forEach((/**
         * @param {?} brush
         * @return {?}
         */
        function (brush) {
            brush.signalNotifier = _this.signalNotifier;
        }));
    };
    /**
     * @return {?}
     */
    MapComponent.prototype.mapOut = /**
     * @return {?}
     */
    function () {
        this.repaint();
        this.reorderLayers();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    MapComponent.prototype.mapOver = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.repaint();
        /** @type {?} */
        var area = this.findAreaByCoords(event.target.coords);
        /** @type {?} */
        var brush = this.findHoverBrush(area);
        this.initContext(brush);
        this.drawCoords(event.target.coords.split(','));
        this.reorderLayers();
    };
    /**
     * @return {?}
     */
    MapComponent.prototype.repaint = /**
     * @return {?}
     */
    function () {
        if (this.canvasMap !== null) {
            this.mainContainer.nativeElement.style.width = this.highlightedImage.nativeElement.width + "px";
            this.mainContainer.nativeElement.style.height = this.highlightedImage.nativeElement.height + "px";
            this.canvasMap.nativeElement.width = this.highlightedImage.nativeElement.width;
            this.canvasMap.nativeElement.height = this.highlightedImage.nativeElement.height;
        }
        this.drawInitialAreas();
    };
    /**
     * @private
     * @return {?}
     */
    MapComponent.prototype.drawInitialAreas = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.areas.forEach((/**
         * @param {?} area
         * @return {?}
         */
        function (area) {
            /** @type {?} */
            var brush = _this.brushesMap[area.brushClass];
            if (brush) {
                _this.initContext(new BrushWithDefaults(brush));
                _this.drawCoords(area.coords.split(',').map((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) { return parseInt(value, 10); })));
            }
        }));
    };
    /**
     * @private
     * @param {?} area
     * @return {?}
     */
    MapComponent.prototype.findHoverBrush = /**
     * @private
     * @param {?} area
     * @return {?}
     */
    function (area) {
        /** @type {?} */
        var brush;
        /** @type {?} */
        var hoverAttribute = ':hover';
        if (area !== undefined && this.brushesMap[area.brushClass + hoverAttribute] !== undefined) {
            brush = new BrushWithDefaults(this.brushesMap[area.brushClass + hoverAttribute]);
        }
        else {
            brush = new BrushWithDefaults(this.brushesMap[hoverAttribute]);
        }
        return brush;
    };
    /**
     * @private
     * @param {?} brush
     * @return {?}
     */
    MapComponent.prototype.initContext = /**
     * @private
     * @param {?} brush
     * @return {?}
     */
    function (brush) {
        this.context.setLineDash(brush.lineDash());
        this.context.strokeStyle = brush.strokeStyle();
        this.context.fillStyle = brush.fillStyle();
        this.context.lineCap = brush.lineCap();
        this.context.lineWidth = brush.lineWidth();
        this.context.lineJoin = brush.lineJoin();
    };
    /**
     * @private
     * @param {?} coords
     * @return {?}
     */
    MapComponent.prototype.drawCoords = /**
     * @private
     * @param {?} coords
     * @return {?}
     */
    function (coords) {
        this.context.beginPath();
        /** @type {?} */
        var i = 0;
        while (i < coords.length) {
            this.context.lineTo(coords[i], coords[i + 1]);
            i += 2;
        }
        this.context.closePath();
        this.context.stroke();
        this.context.fill();
    };
    /**
     * @private
     * @return {?}
     */
    MapComponent.prototype.reorderLayers = /**
     * @private
     * @return {?}
     */
    function () {
        this.highlightedImage.nativeElement.before(this.canvasMap.nativeElement);
    };
    /**
     * @private
     * @param {?} coords
     * @return {?}
     */
    MapComponent.prototype.findAreaByCoords = /**
     * @private
     * @param {?} coords
     * @return {?}
     */
    function (coords) {
        return this.areas.find((/**
         * @param {?} area
         * @return {?}
         */
        function (area) { return area.coords === coords; }));
    };
    /**
     * @private
     * @return {?}
     */
    MapComponent.prototype.prepareBrushesMap = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.brushes.forEach((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return _this.brushesMap[item.brushClass] = item; }));
    };
    MapComponent.decorators = [
        { type: Component, args: [{
                    selector: 'highlight-map',
                    template: "<div class=\"highlight-container\" #mainContainer >\r\n  <img [src]=\"src\" useMap=\"#{{name}}\" class=\"highlight-image\" (load)=\"repaint()\" #highlightedImage>\r\n  <canvas class=\"highlight-canvas\" #canvasMap></canvas>\r\n  <map [name]=\"name\" (mouseover)=\"mapOver($event)\" (mouseout)=\"mapOut()\">\r\n    <ng-content></ng-content>\r\n  </map>\r\n</div>\r\n",
                    styles: ["div.highlight-container{position:relative;background-repeat:no-repeat;padding:0;text-align:left}div.highlight-container .highlight-image{opacity:.000001}div.highlight-container .highlight-canvas{position:absolute;top:0;left:0}"]
                }] }
    ];
    /** @nocollapse */
    MapComponent.ctorParameters = function () { return []; };
    MapComponent.propDecorators = {
        mainContainer: [{ type: ViewChild, args: ['mainContainer',] }],
        canvasMap: [{ type: ViewChild, args: ['canvasMap',] }],
        highlightedImage: [{ type: ViewChild, args: ['highlightedImage',] }],
        areas: [{ type: ContentChildren, args: [AreaComponent,] }],
        brushes: [{ type: ContentChildren, args: [BrushComponent,] }],
        src: [{ type: Input }],
        name: [{ type: Input }]
    };
    return MapComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MapModule = /** @class */ (function () {
    function MapModule() {
    }
    MapModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MapComponent, AreaComponent, BrushComponent],
                    imports: [
                        CommonModule
                    ],
                    exports: [MapComponent, AreaComponent, BrushComponent]
                },] }
    ];
    return MapModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MapComponent, MapModule, AreaComponent as ɵa, BrushComponent as ɵb };

//# sourceMappingURL=marciniak-map.js.map