import { OnChanges, SimpleChanges } from '@angular/core';
import SignalNotifier from './signal-notifier';
export declare class BrushComponent implements OnChanges {
    constructor();
    readonly brushClass: string;
    lineWidth?: number;
    lineCap?: CanvasLineCap;
    lineJoin?: CanvasLineJoin;
    strokeStyle?: string | CanvasGradient | CanvasPattern;
    lineDash?: string | number[];
    fillStyle?: string | CanvasGradient | CanvasPattern;
    signalNotifier: SignalNotifier;
    ngOnChanges(changes: SimpleChanges): void;
}
export declare class BrushWithDefaults {
    private readonly brush;
    constructor(brush: BrushComponent);
    lineDash(): number[];
    lineCap(): CanvasLineCap;
    lineWidth(): number;
    lineJoin(): CanvasLineJoin;
    strokeStyle(): string | CanvasGradient | CanvasPattern;
    fillStyle(): string | CanvasGradient | CanvasPattern;
    getValue<T>(field: string, defaultValue: T): T;
}
